#include "plugin.h"
#include "utils.h"

void plugin_register_password(const char *key, const char *password)
{
    printf("password for %s: %s\n", key, password);
}

char *plugin_host_to_string(plugin_target *host)
{
	return inet_ntoa(*host);
}

plugin_target *plugin_host_by_name(char *host)
{
	struct hostent *he;
	plugin_target *ip;
	
	ip = (plugin_target *) malloc(sizeof(plugin_target));
	
	if (!inet_aton(host, ip)) {
		free(ip);
		he = gethostbyname(host);
        if (!he) {        
            return 0;
        }
        ip = (plugin_target *) he->h_addr;
    }
    
    return ip;
}

int plugin_socket_open(plugin_target *host, plugin_port port)
{
    int sockfd;
    struct sockaddr_in addr;
    
    addr.sin_addr = *host;
    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    
    sockfd = socket(PF_INET, SOCK_STREAM, 0);
    if (sockfd == -1) {
		return -1;
    }
    
    if (connect(sockfd, (struct sockaddr *) &addr, sizeof(addr)) == -1) {
		return -2;
    }
    
    return sockfd;
}

void plugin_socket_close(int sockfd)
{
    close(sockfd);
}

